<template>
  <div :class="['fact-segment', 'fact-segment-' + randomColor]">
    <div class="fact-padding">
      <div class="fact-segment__image-container">
        <div ref="imageContainer"></div>
      </div>

      <WikiLogo
        v-if="first"
        :title="title"
        :randomColor="randomColor"
        :logoElement="logoElement"
        class="fact-segment__logo"
      />

      <p style="width: 70%">
        <span :class="['fact-segment__text', randomColor]"> {{ text }}</span>
      </p>

      <WikiAttribution
        class="fact-segment__attribution"
        :imageAttribution="imageAttribution"
      />
    </div>
  </div>
</template>

<script lang="ts" setup>
import { onMounted, ref } from 'vue';
import WikiLogo from './WikiLogo.vue';
import WikiAttribution from './WikiAttribution.vue';

const props = defineProps<{
  title: string;
  text: string;
  imageUrl: string;
  imageElement: HTMLImageElement | undefined;
  imageAlignment: string;
  randomColor: string;
  imageAttribution: string;
  narrationTime: number;
  playbackSpeed: number;
  kenBurns: string;
  first: boolean;
  logoElement: HTMLImageElement | undefined;
}>();

const animationSpeed = `calc(20s / ${props.playbackSpeed})`;
const imageContainer = ref<HTMLDivElement | null>(null);

onMounted(() => {
  const image = props.imageElement;
  if (!image) return;

  image.className = 'fact-segment__image';
  if (imageContainer.value === null) return;
  const dataAttribute = imageContainer.value
    ?.getAttributeNames()
    .find((attr) => attr.startsWith('data-v-'));
  if (dataAttribute) {
    image.setAttribute(dataAttribute, '');
  }
  imageContainer.value.appendChild(image);
});
</script>

<style scoped lang="less">
.fact-segment-white {
  background-color: black;
}

.fact-segment-black,
.fact-segment-blue {
  background-color: white;
}

.fact-segment {
  position: absolute;

  top: 0;
  bottom: 0;
  left: 0;
  right: 0;
  display: flex;
  flex-direction: column;

  .fact-padding {
    padding: 50px;
  }

  &__image-container {
    position: relative;
    aspect-ratio: 4 / 3;
    overflow: hidden;
  }

  &__image {
    position: absolute;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;
    object-fit: cover;
    object-position: v-bind(imageAlignment);
    animation: v-bind(kenBurns) v-bind(animationSpeed) ease infinite;
  }

  &__attribution {
    position: absolute;
    bottom: 50px;
  }

  &__text {
    font-size: 46px;
    line-height: 86px;
    padding: 12px 24px;
    box-decoration-break: clone;
    -webkit-box-decoration-break: clone;
  }

  &__logo {
    margin-top: 50px;
  }
}
</style>
